unit hiCharset;

interface

uses Kol,Share,Debug;

type
  THICharset = class(TDebug)
   private
    FResult:string;
   public
    _prop_Type:byte;

    _data_Text:THI_Event;
    _event_onCharset:THI_Event;

    procedure _work_doCharset0(var _Data:TData; Index:word);
    procedure _work_doCharset1(var _Data:TData; Index:word);
    procedure _work_doCharset2(var _Data:TData; Index:word);
    procedure _work_doCharset3(var _Data:TData; Index:word);
    procedure _work_doCharset4(var _Data:TData; Index:word);
    procedure _work_doCharset5(var _Data:TData; Index:word);
    procedure _var_Result(var _Data:TData; Index:word);
  end;

function Koi8ToWin(const s:string):string;
function Base64_Code(const s:string):string;
function Base64_Decode(const s:string):string;
function DosToWin(const Text:string):string;

implementation

const base64ABC:string = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';

function Base64_Code(const s:string):string;
var rlen,len:cardinal;
    i,l:cardinal;
    strIn:string;
begin
  Result := '';
  if s = '' then exit;
  rlen := Length(s);
  if rlen mod 3 = 1 then
   strIn := s + #0#0
  else if rlen mod 3 = 2 then
   strIn := s + #0
  else strIn := s;
  len := Length(strIn);

  i := 1;
  while i <= len-2 do
   begin
    Result := Result + base64ABC[byte(strIn[i]) shr 2 + 1] +
                       base64ABC[(byte(strIn[i]) and $03) shl 4 + byte(strIn[i+1]) shr 4 + 1] +
                       base64ABC[(byte(strIn[i+1]) and $0f) shl 2 + byte(strIn[i+2]) shr 6 + 1] +
                       base64ABC[(byte(strIn[i+2]) and $3f) + 1];

    inc(i,3);
   end;
  if rlen mod 3 = 1 then
   Result[length(result)-1] := '=';
  if rlen mod 3 > 0 then
   Result[length(result)] := '=';
end;

function Base64_Decode(const s:string):string;
var i,len:cardinal;
    strIn:string;
 function Index(c:char):byte;
 var i:byte;
 begin
    if c = '=' then
     Result := 0
    else
    for i := 1 to 64 do
     if base64ABC[i] = c then
      begin
        Result := i-1;
        break;
      end;
 end;
begin
  strIn := s;
  len := length(strIn);
  i := 1;
  Result := '';
  while i <= len-3 do
   begin
    Result := Result + char(Index(strIn[i]) shl 2 + Index(strIn[i+1]) shr 4) +
                       char((Index(strIn[i+1]) and $0f) shl 4 + Index(strIn[i+2]) shr 2) +
                       char((Index(strIn[i+2]) and $03) shl 6 + Index(strIn[i+3]));
    inc(i,4);
   end;
  if strIn[len-1] = '=' then
   SetLength(Result,Length(Result)-2)
  else if strIn[len] = '=' then
   SetLength(Result,Length(Result)-1);
end;

function Koi8ToWin(const s:string):string;
type
  TConvertChars = array [#128..#255] of char;
const
  Win_KoiChars: TConvertChars = (
  #128,#129,#130,#131,#132,#133,#134,#135,#136,#137,#060,#139,#140,#141,#142,#143,
  #144,#145,#146,#147,#148,#169,#150,#151,#152,#153,#154,#062,#176,#157,#183,#159,
  #160,#246,#247,#074,#164,#231,#166,#167,#179,#169,#180,#060,#172,#173,#174,#183,
  #156,#177,#073,#105,#199,#181,#182,#158,#163,#191,#164,#062,#106,#189,#190,#167,
  #225,#226,#247,#231,#228,#229,#246,#250,#233,#234,#235,#236,#237,#238,#239,#240,
  #242,#243,#244,#245,#230,#232,#227,#254,#251,#253,#154,#249,#248,#252,#224,#241,
  #193,#194,#215,#199,#196,#197,#214,#218,#201,#202,#203,#204,#205,#206,#207,#208,
  #210,#211,#212,#213,#198,#200,#195,#222,#219,#221,#223,#217,#216,#220,#192,#209);

  Koi_WinChars: TConvertChars = (
  #128,#129,#130,#131,#132,#133,#134,#135,#136,#137,#138,#139,#140,#141,#142,#143,
  #144,#145,#146,#147,#148,#149,#150,#151,#152,#153,#218,#155,#176,#157,#183,#159,
  #160,#161,#162,#184,#186,#165,#166,#191,#168,#169,#170,#171,#172,#173,#174,#175,
  #156,#177,#178,#168,#170,#181,#182,#175,#184,#185,#186,#187,#188,#189,#190,#185,
  #254,#224,#225,#246,#228,#229,#244,#227,#245,#232,#233,#234,#235,#236,#237,#238,
  #239,#255,#240,#241,#242,#243,#230,#226,#252,#251,#231,#248,#253,#249,#247,#250,
  #222,#192,#193,#214,#196,#197,#212,#195,#213,#200,#201,#202,#203,#204,#205,#206,
  #207,#223,#208,#209,#210,#211,#198,#194,#220,#219,#199,#216,#221,#217,#215,#218);

var
  i: integer;
begin
  Result := s;
  for i := 1 to Length(Result) do
    if Result[i] > #127 then
      Result[i] := Koi_WinChars[Result[i]];
end;

procedure THICharset._work_doCharset0;
begin
   FResult := DosToWin(ReadString(_Data,_data_Text,''));
   _hi_OnEvent(_event_onCharset,FResult);
end;

function DosToWin(const Text:string):string;
var i:cardinal;
begin
   Result := Text;
   if Result <> '' then
   for i := 1 to Length(Result) do
    if Result[i] in [#128..#175] then
      Result[i] := chr(ord(Result[i]) + 64)
    else if Result[i] in [#224..#239] then
      Result[i] := chr(ord(Result[i]) + 16)
    else if Result[i] = #240 then
      Result[i] := ''
    else if Result[i] = #241 then
      Result[i] := '';
end;

procedure THICharset._work_doCharset1;
var i:cardinal;
    Result:string;
begin
   Result := ReadString(_Data,_data_Text,'');
   if Result <> '' then
   for i := 1 to Length(Result) do
    if Result[i] in [''..''] then
      Result[i] := chr(ord(Result[i]) - 64)
    else if Result[i] in [''..''] then
      Result[i] := chr(ord(Result[i]) - 16)
    else if Result[i] = '' then
      Result[i] := #240
    else if Result[i] = '' then
      Result[i] := #241;
    FResult := Result;
    _hi_OnEvent(_event_onCharset,Result);
end;

procedure THICharset._work_doCharset2;
const en:string = 'qwertyuiop[]asdfghjkl;''zxcvbnm,./QWERTYUIOP{}ASDFGHJKL:"ZXCVBNM<>?';
      ru:string = '.,';
var i,p:cardinal;
    Result:string;
begin
   Result := ReadString(_Data,_data_Text,'');
   if Result <> '' then
    for i := 1 to Length(Result) do
     begin
        p := pos(Result[i],en);
        if p > 0 then
         Result[i] := ru[p];
     end;
   FResult := Result;
   _hi_OnEvent(_event_onCharset,Result);
end;

procedure THICharset._work_doCharset3;
begin
  FResult := Koi8ToWin(ReadString(_Data,_data_Text,''));
  _hi_OnEvent(_event_onCharset, FResult);
end;

procedure THICharset._work_doCharset4;
begin
   FResult := Base64_Code(ReadString(_Data,_data_Text,''));
   _hi_OnEvent(_event_onCharset,FResult);
end;

procedure THICharset._work_doCharset5;
begin
   FResult := Base64_DeCode(ReadString(_Data,_data_Text,''));
   _hi_OnEvent(_event_onCharset,FResult);
end;

procedure THICharset._var_Result;
begin
   _Data.data_type:=data_str;
   _Data.sdata:=FResult;
end;

end.
